#!/bin/bash
set -e

DOCKER_DIR="$(dirname $(realpath $0))"
. ${DOCKER_DIR}/env.sh

BUILD=build-meson
mkdir -p $BUILD

if [ ! -f build-meson/config.h ]; then
    cp build-autoconf/config.h build-meson/
    cp build-autoconf/build/build_info.h build-meson/
fi

time \
    CC=clang \
    CXX=clang++ \
    LDFLAGS="-fuse-ld=lld" \
    meson $BUILD \
    --prefix=$PREFIX \
    -Dsearch=$PREFIX \
    -Dwerror=true \
    -Doptimization=0 \
    -Dbackend_max_links=4 \
    -Db_sanitize=address \
    -Db_lundef=false

time ninja -C $BUILD
