DS_TESTS =

### ds

noinst_LIBRARIES += libds.a
libds_a_SOURCES = \
        ../src/ds/box.cpp \
        ../src/ds/clock.cpp \
        ../src/ds/collection.cpp \
        ../src/ds/common.cpp \
        ../src/ds/conf.cpp \
        ../src/ds/date-time.cpp \
        ../src/ds/elapsed.cpp \
        ../src/ds/enum.cpp \
        ../src/ds/exception.cpp \
        ../src/ds/http.cpp \
        ../src/ds/json.cpp \
        ../src/ds/latency-statistics.cpp \
        ../src/ds/log.cpp \
        ../src/ds/random.cpp \
        ../src/ds/reflect.cpp \
        ../src/ds/str.cpp \
        ../src/ds/stack-trace.cpp \
        ../src/ds/system.cpp \
        ../src/ds/sqlite3/ds-sqlite3.cpp \
        ../src/ds/tracing.cpp
libds_a_CPPFLAGS = \
        -DDS_SYSCONFDIR='"$(sysconfdir)"' \
        -DDS_DATADIR='"$(datadir)"' \
        $(AM_CPPFLAGS) \
        $(BOOST_CPPFLAGS)
libds_a_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
libds_a_LIB = \
        libds.a \
        $(BOOST_SYSTEM_LIB) \
        $(BOOST_CHRONO_LIB) \
        $(BOOST_FILESYSTEM_LIB) \
        $(JSONC_LIBS) \
        $(PTHREAD_LIBS)

check_LIBRARIES += libds-catch-main.a
libds_catch_main_a_SOURCES = \
        ../src/ds/catch/main.cpp
libds_catch_main_a_CPPFLAGS = \
        $(libds_a_CPPFLAGS)
libds_catch_main_a_LIB = \
        libds-catch-main.a

DS_TESTS += ds-test
ds_test_SOURCES = \
        ../src/ds/box-test.cpp \
        ../src/ds/clock-test.cpp \
        ../src/ds/collection-test.cpp \
        ../src/ds/common-test.cpp \
        ../src/ds/conf-test.cpp \
        ../src/ds/date-time-test.cpp \
        ../src/ds/enum-test.cpp \
        ../src/ds/exception-test.cpp \
        ../src/ds/http-test.cpp \
        ../src/ds/json-test.cpp \
        ../src/ds/latency-statistics-test.cpp \
        ../src/ds/log-test.cpp \
        ../src/ds/str-test.cpp \
        ../src/ds/random-test.cpp \
        ../src/ds/reflect-test.cpp \
        ../src/ds/stack-trace-test.cpp \
        ../src/ds/system-test.cpp \
        ../src/ds/tracing-test.cpp \
        ../src/ds/sqlite3/ds-sqlite3-test.cpp
ds_test_CPPFLAGS = \
        -DDS_SRC_DIR='"$(abs_srcdir)/../src/ds/"' \
        $(libds_a_CPPFLAGS)
ds_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(libds_a_LIB) \
        $(SQLITE3_LIBS)

### ds-crypt

noinst_LIBRARIES += libds-crypt.a
libds_crypt_a_SOURCES = \
        ../src/ds-crypt/digest.cpp
libds_crypt_a_CPPFLAGS = \
        $(libds_a_CPPFLAGS)
libds_crypt_a_LIB = \
        libds-crypt.a \
        $(OPENSSL_LIBS) \
        $(libds_a_LIB)

DS_TESTS += ds-crypt-test
ds_crypt_test_SOURCES = \
        ../src/ds-crypt/digest-test.cpp
ds_crypt_test_CPPFLAGS = \
        $(libds_crypt_a_CPPFLAGS)
ds_crypt_test_LDADD = \
        $(libds_crypt_a_LIB) \
        $(libds_catch_main_a_LIB)


### ds-locale

noinst_LIBRARIES += libds-locale.a
libds_locale_a_SOURCES = \
        ../src/ds/locale/backend.cpp \
        ../src/ds/locale/ds-locale.cpp \
        ../src/ds/locale/messages.cpp \
        ../src/ds/locale/test.cpp
libds_locale_a_CPPFLAGS = \
        -DDS_LOCALEDIR='"$(localedir)"' \
        $(libds_a_CPPFLAGS)
libds_locale_a_LIB = \
        libds-locale.a \
        $(BOOST_LOCALE_LIB) \
        $(libds_a_LIB)

DS_TESTS += ds-locale-test
ds_locale_test_SOURCES = \
        ../src/ds/locale/backend-test.cpp \
        ../src/ds/locale/ds-locale-test.cpp \
        ../src/ds/locale/messages-test.cpp
ds_locale_test_CPPFLAGS = \
        -DDS_LOCALE_SRC_DIR='"$(abs_srcdir)/../src/ds/locale/"' \
        $(libds_locale_a_CPPFLAGS)
ds_locale_test_LDADD = \
        $(libds_locale_a_LIB) \
        $(libds_catch_main_a_LIB)


### ds-asio

noinst_LIBRARIES += libds-asio.a
libds_asio_a_SOURCES = \
	../src/ds/asio/abortable.cpp \
	../src/ds/asio/back-off.cpp \
        ../src/ds/asio/ds-signal.cpp \
	../src/ds/asio/io-service.cpp \
	../src/ds/asio/latency-watchdog.cpp \
	../src/ds/asio/loop-impl.cpp \
	../src/ds/asio/loop.cpp \
	../src/ds/asio/moderation-timer.cpp \
        ../src/ds/asio/promise.cpp \
        ../src/ds/asio/property.cpp \
	../src/ds/asio/reconnect-timer.cpp \
	../src/ds/asio/resource.cpp \
	../src/ds/asio/retryer.cpp \
	../src/ds/asio/state-poller.cpp \
	../src/ds/asio/timer.cpp \
	../src/ds/asio/thread-pool.cpp \
	../src/ds/asio/watchdog.cpp
libds_asio_a_CPPFLAGS = \
        $(libds_a_CPPFLAGS)
libds_asio_a_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
libds_asio_a_LIB = \
        libds-asio.a \
        $(libds_a_LIB) \
        $(libds_crypt_a_LIB)

DS_TESTS += ds-asio-test
ds_asio_test_SOURCES = \
        ../src/ds/asio/abortable-test.cpp \
	../src/ds/asio/back-off-test.cpp \
        ../src/ds/asio/ds-signal-test.cpp \
        ../src/ds/asio/io-service-test.cpp \
	../src/ds/asio/latency-watchdog-test.cpp \
	../src/ds/asio/loop-test.cpp \
	../src/ds/asio/moderation-timer-test.cpp \
        ../src/ds/asio/reconnect-timer-test.cpp \
        ../src/ds/asio/promise-test.cpp \
        ../src/ds/asio/property-test.cpp \
	../src/ds/asio/resource-test.cpp \
	../src/ds/asio/retryer-test.cpp \
	../src/ds/asio/state-poller-test.cpp \
        ../src/ds/asio/timer-test.cpp \
	../src/ds/asio/thread-pool-test.cpp \
        ../src/ds/asio/watchdog-test.cpp
ds_asio_test_CPPFLAGS = \
        $(libds_asio_a_CPPFLAGS)
ds_asio_test_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
ds_asio_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(libds_asio_a_LIB)


### ds-net

noinst_LIBRARIES += libds-net.a
libds_net_a_SOURCES = \
        ../src/ds-net/buffered-message-writer.cpp \
        ../src/ds-net/message-stream.cpp \
        ../src/ds-net/tcp-acceptor.cpp \
        ../src/ds-net/session.cpp \
        ../src/ds-net/session-base.cpp \
        ../src/ds-net/signalr.cpp \
        ../src/ds-net/ssl.cpp \
        ../src/ds-net/websocket.cpp
libds_net_a_CPPFLAGS = \
        $(libds_a_CPPFLAGS)
libds_net_a_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
libds_net_a_LIB = \
        libds-net.a \
        $(OPENSSL_LIBS) \
        $(libds_asio_a_LIB)

DS_TESTS += ds-net-test
ds_net_test_SOURCES = \
        ../src/ds-net/buffered-message-writer-test.cpp \
        ../src/ds-net/session-base-test.cpp \
        ../src/ds-net/session-test.cpp \
        ../src/ds-net/signalr-test.cpp \
        ../src/ds-net/tcp-acceptor-test.cpp \
        ../src/ds-net/websocket-test.cpp
ds_net_test_CPPFLAGS = \
        $(libds_net_a_CPPFLAGS)
ds_net_test_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
ds_net_test_LDADD = \
        $(libds_net_a_LIB) \
        $(libds_catch_main_a_LIB)


### ds-avahi

noinst_LIBRARIES += libds-avahi.a
libds_avahi_a_SOURCES = \
        ../src/ds-avahi/client.cpp \
        ../src/ds-avahi/lookup.cpp \
        ../src/ds-avahi/publish.cpp
libds_avahi_a_CPPFLAGS = \
        $(libds_a_CPPFLAGS) \
        $(AVAHI_CFLAGS)
libds_avahi_a_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
libds_avahi_a_LIB = \
        libds-avahi.a \
        $(OPENSSL_LIBS) \
        $(AVAHI_LIBS) \
        $(libds_asio_a_LIB)

noinst_PROGRAMS+= ds-avahi-test
ds_avahi_test_SOURCES = \
        ../src/ds-avahi/test.cpp
ds_avahi_test_CPPFLAGS = \
        $(libds_avahi_a_CPPFLAGS)
ds_avahi_test_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
ds_avahi_test_LDADD = \
        $(libds_avahi_a_LIB) \
        $(libds_catch_main_a_LIB)

### ds-api

noinst_LIBRARIES += libds-api.a
libds_api_a_SOURCES = \
	../src/ds-api/array.cpp \
	../src/ds-api/event.cpp \
	../src/ds-api/http-server.cpp \
	../src/ds-api/inside.cpp \
	../src/ds-api/notifications.cpp \
	../src/ds-api/rest.cpp \
	../src/ds-api/route-segments.cpp \
	../src/ds-api/service.cpp \
	../src/ds-api/translatable.cpp
libds_api_a_CPPFLAGS = \
        $(libds_net_a_CPPFLAGS)
libds_api_a_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
libds_api_a_LIB = \
        libds-api.a \
        $(libds_net_a_LIB) \
        $(ATOMIC_LDFLAGS)

DS_TESTS += ds-api-test
ds_api_test_SOURCES = \
	../src/ds-api/array-test.cpp \
	../src/ds-api/event-test.cpp \
	../src/ds-api/http-server-test.cpp \
	../src/ds-api/notifications-test.cpp \
	../src/ds-api/rest-test.cpp \
	../src/ds-api/route-segments-test.cpp \
	../src/ds-api/service-test.cpp
ds_api_test_CPPFLAGS = \
        $(libds_api_a_CPPFLAGS)
ds_api_test_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
ds_api_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(libds_api_a_LIB)

### ds-model

noinst_LIBRARIES += libds-model.a
libds_model_a_SOURCES = \
	../src/ds-model/apartment.cpp \
	../src/ds-model/apartment-api.cpp \
	../src/ds-model/devices.cpp \
	../src/ds-model/groups.cpp \
	../src/ds-model/installation.cpp \
	../src/ds-model/meterings.cpp \
	../src/ds-model/model.cpp \
	../src/ds-model/remote-connectivity.cpp \
	../src/ds-model/scenarios.cpp \
	../src/ds-model/user-defined-states.cpp \
	../src/ds-model/api-revision.cpp
libds_model_a_CPPFLAGS = \
        $(libds_api_a_CPPFLAGS)
libds_model_a_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
libds_model_a_LIB = \
        libds-model.a \
        $(libds_api_a_LIB)

DS_TESTS += ds-model-test
ds_model_test_SOURCES = \
	../src/ds-model/apartment-api-test.cpp \
	../src/ds-model/model-test.cpp \
	../src/ds-model/scenarios-test.cpp
ds_model_test_CPPFLAGS = \
        $(libds_model_a_CPPFLAGS)
ds_model_test_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
ds_model_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(libds_model_a_LIB)

### ds-media-library

noinst_LIBRARIES += libds-media-library.a
libds_media_library_a_SOURCES = \
	../src/ds-media-library/media-library-api.cpp \
	../src/ds-model/media-library.cpp
libds_media_library_a_CPPFLAGS = \
        $(libds_api_a_CPPFLAGS)
libds_media_library_a_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
libds_media_library_a_LIB = \
        libds-media-library.a \
        $(libds_api_a_LIB)

DS_TESTS += ds-media-library-test
ds_media_library_test_SOURCES = \
	../src/ds-media-library/media-library-api-test.cpp
ds_media_library_test_CPPFLAGS = \
        $(libds_media_library_a_CPPFLAGS)
ds_media_library_test_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
ds_media_library_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(libds_media_library_a_LIB)

### ds-backend

noinst_LIBRARIES += libds-backend.a
libds_backend_a_SOURCES = \
	../src/ds-backend/connector.cpp \
	../src/ds-backend/protocol.cpp \
	../src/ds-backend/uploader.cpp \
	../src/ds-backend/wss-client.cpp
libds_backend_a_CPPFLAGS = \
        $(libds_api_a_CPPFLAGS)
libds_backend_a_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
libds_backend_a_LIB = \
        libds-backend.a \
        $(libds_api_a_LIB) \
        $(libds_net_a_LIB)

DS_TESTS += ds-backend-test
ds_backend_test_SOURCES = \
	../src/ds-backend/connector-test.cpp \
	../src/ds-backend/uploader-test.cpp
ds_backend_test_CPPFLAGS = \
        $(libds_backend_a_CPPFLAGS)
ds_backend_test_CXXFLAGS = \
        $(PTHREAD_CFLAGS)
ds_backend_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(libds_backend_a_LIB)

bin_PROGRAMS += ds-backend-cat
ds_backend_cat_SOURCES = \
	../src/ds-backend/cat-main.cpp
ds_backend_cat_CXXFLAGS = \
		$(PTHREAD_CFLAGS)
ds_backend_cat_CPPFLAGS = \
        $(libds_a_CPPFLAGS) \
	$(LIBDSUID_CFLAGS)
ds_backend_cat_LDADD = \
        $(libds_backend_a_LIB) \
        $(libds_api_a_LIB)

### ds integration

check_PROGRAMS += $(DS_TESTS)
TESTS += $(DS_TESTS)

### dss

libdsscore_a_SOURCES =  \
	../src/view/device-config.capnp.dss.cpp \
	../src/view/umr200-config.cpp \
	../src/backend-vdcs.cpp \
	../src/base.cpp \
	../src/bus.cpp \
	../src/bonjour.cpp \
	../src/businterface.cpp \
	../src/comm-channel.cpp \
	../src/controller-statuses.cpp \
	../src/datetools.cpp \
	../src/defaultbuseventsink.cpp \
	../src/device-info.cpp \
	../src/ds-apartment/api-revision.cpp \
	../src/ds-apartment/ds-devices.cpp \
	../src/ds-apartment/installation.cpp \
	../src/ds-apartment/remote-connectivity.cpp \
	../src/ds-backend/measurements-source.cpp \
	../src/ds-backend/module.cpp \
	../src/ds-backend/signals-source.cpp \
	../src/ds-backend/timed-measurements-source.cpp \
	../src/ds-backend/uploader.cpp \
	../src/ds-backend/wss-client.cpp \
	../src/ds485/dsactionrequest.cpp \
	../src/ds485/dsbusinterface.cpp \
	../src/ds485/dsbusinterfaceobj.cpp \
	../src/ds485/dsmeteringbusinterface.cpp \
	../src/ds485types.cpp \
	../src/ds485-device.cpp \
	../src/ds485-query.cpp \
	../src/ds485-modify.cpp \
	../src/dsa-http-client.cpp \
	../src/dss.cpp \
	../src/event.cpp \
	../src/event/event_create.cpp \
	../src/event/event_fields.cpp \
	../src/eventcollector.cpp \
	../src/eventinterpreterplugins.cpp \
	../src/eventinterpretersystemplugins.cpp \
	../src/eventsubscriptionsession.cpp \
	../src/exception.cpp \
	../src/expatparser.cpp \
	../src/handler/action-execute.cpp \
	../src/handler/event-logger.cpp \
	../src/handler/system_handlers.cpp \
	../src/handler/system_states.cpp \
	../src/handler/system_triggers.cpp \
	../src/hasher.cpp \
	../src/heatingregistering.cpp \
	../src/http_client.cpp \
	../src/logger.cpp \
	../src/metering/archives.cpp \
	../src/metering/config.cpp \
	../src/metering/metering.cpp \
	../src/metering/power-states.cpp \
	../src/metering/rrd-interface.cpp \
	../src/model-features.cpp \
	../src/model/addressablemodelitem.cpp \
	../src/model/apartment.cpp \
	../src/model/autoclustermaintenance.cpp \
	../src/model/behavior.cpp \
	../src/model/busscanner.cpp \
	../src/model/buttonattributes.cpp \
	../src/model/buttonmanipulator.cpp \
	../src/model/cluster.cpp \
	../src/model/status-field.cpp \
	../src/model/status.cpp \
	../src/model/data_types.cpp \
	../src/model/device.cpp \
	../src/model/device-data.cpp \
	../src/model/device-property-tree.cpp \
	../src/model/devicecontainer.cpp \
	../src/model/deviceinterface.cpp \
	../src/model/devicereference.cpp \
	../src/model/dsmeter.cpp \
	../src/model/group.cpp \
	../src/model/modelconst.cpp \
	../src/model/modelevent.cpp \
	../src/model/modelmaintenance.cpp \
	../src/model/modelpersistence.cpp \
	../src/model/nonaddressablemodelitem.cpp \
	../src/model/physicalmodelitem.cpp \
	../src/model/powerline.cpp \
	../src/model/scenehelper.cpp \
	../src/model/set.cpp \
	../src/model/setsplitter.cpp \
	../src/model/shadeattributes.cpp \
	../src/model/shademanipulator.cpp \
	../src/model/state.cpp \
	../src/model/zone.cpp \
	../src/model/floor.cpp \
	../src/monitor_tasks.cpp \
	../src/property-parser.cpp \
	../src/propertyquery.cpp \
	../src/propertysystem.cpp \
	../src/propertysystem_common_paths.cpp \
	../src/protobufjson.cpp \
	../src/reregister-devices.cpp \
	../src/sceneaccess.cpp \
	../src/security/privilege.cpp \
	../src/security/security.cpp \
	../src/security/user.cpp \
	../src/sensoraggregator.cpp \
	../src/sensor_data_uploader.cpp \
	../src/session.cpp \
	../src/sessionmanager.cpp \
	../src/setbuilder.cpp \
	../src/sqlite3_wrapper.cc \
	../src/storagetools.cpp \
	../src/stringconverter.cpp \
	../src/structuremanipulator.cpp \
	../src/subscription.cpp \
	../src/subscription_profiler.cpp \
	../src/subsystem.cpp \
	../src/syncevent.cpp \
	../src/systemcondition.cpp \
	../src/taskprocessor.cpp \
	../src/test-device-presence.cpp \
	../src/util.cpp \
	../src/vdc.cpp \
	../src/vdc-connection.cpp \
	../src/vdc-db.cpp \
	../src/vdc-element-reader.cpp \
	../src/vdc-token.cpp \
	../src/watchdog.cpp \
	../src/web/handler/apartmentrequesthandler.cpp \
	../src/web/handler/circuitrequesthandler.cpp \
	../src/web/handler/databaserequesthandler.cc \
	../src/web/handler/deviceinterfacerequesthandler.cpp \
	../src/web/handler/devicerequesthandler.cpp \
	../src/web/handler/eventrequesthandler.cpp \
	../src/web/handler/internalrequesthandler.cpp \
	../src/web/handler/jsonhelper.cpp \
	../src/web/handler/meteringrequesthandler.cpp \
	../src/web/handler/propertyrequesthandler.cpp \
	../src/web/handler/setrequesthandler.cpp \
	../src/web/handler/staterequesthandler.cpp \
	../src/web/handler/structurerequesthandler.cpp \
	../src/web/handler/subscriptionrequesthandler.cpp \
	../src/web/handler/systemrequesthandler.cpp \
	../src/web/handler/zonerequesthandler.cpp \
	../src/web/restful.cpp \
	../src/web/webrequests.cpp \
	../src/web/webserver.cpp \
	../src/web/websocket/connection.cpp \
	../src/web/websocket/identifydevice.cpp \
	../src/web/websocket/jsonapiserver.cpp \
	../src/web/websocket/message.cpp \
	../src/web/websocket/observerbuilder.cpp \
	../src/web/websocket/simpleserver.cpp \
	../src/webservice_api.cpp \
	../src/webservice_connection.cpp \
	../src/ds-model.cpp \
	../src/ds-scenarios.cpp \
	../src/cache/cache-db.cpp \
	../src/cache/apartment-proxy.cpp \
	../src/hal/hardware-abstraction.cpp \
	../src/hal/hal-device.cpp \
	../src/hal/light-device.cpp \
	../src/hal/shade-device.cpp \
	../src/hal/joker-device.cpp \
	../src/hal/audio-device.cpp \
	../src/hal/climate-device.cpp \
	../src/cache/cache-updater.cpp

if BUILD_SCRIPTING
noinst_LIBRARIES += libscripting.a
libscripting_a_SOURCES = \
	../src/scripting/jscluster.cpp \
	../src/scripting/jscurl.cpp \
	../src/scripting/jsdatabase.cpp \
	../src/scripting/jsevent.cpp \
	../src/scripting/jshandler.cpp \
	../src/scripting/jslogger.cpp \
	../src/scripting/jsmodel.cpp \
	../src/scripting/jsproperty.cpp \
	../src/scripting/jswebservice.cpp \
	../src/scripting/scriptobject.cpp \
	../src/eventinterpreterjsplugins.cpp

libscripting_a_CPPFLAGS = \
        $(AM_CPPFLAGS) \
        $(BOOST_CPPFLAGS) \
        -I$(top_srcdir) \
        -I$(top_builddir)/src
libscripting_a_CXXFLAGS = \
	$(DSM_API_CFLAGS) \
	$(JS_CFLAGS) \
	$(LIBDSUID_CFLAGS)
else
libdsscore_a_SOURCES +=  \
	../src/eventinterpreterjsplugins-dummy.cpp
endif

libcivetweb_a_SOURCES = \
	../external/civetweb/civetweb.c \
	../external/civetweb/civetweb-ds-log.cpp
libcivetweb_a_CPPFLAGS = \
	-DDS_SYSCONFDIR='"$(sysconfdir)"' \
	-DDS_DATADIR='"$(datadir)"' \
	$(AM_CPPFLAGS) \
	$(BOOST_CPPFLAGS)
libcivetweb_a_CFLAGS = \
	$(OPENSSL_CFLAGS)

libunix_a_SOURCES = \
	../unix/systeminfo.cpp \
	../unix/thread.cpp

dsstests_SOURCES = \
	../tests/000_dss_instance_fixture_test.cpp \
	../tests/apartment_xml_tests.cpp \
	../tests/basetests.cpp \
	../tests/circuitrequesthandlertest.cpp \
	../tests/datetoolstests.cpp \
	../tests/deviceinterfacerequesthandlertest.cpp \
	../tests/devicerequesthandlertest.cpp \
	../tests/zonerequesthandlertest.cpp \
	../tests/devicetests.cpp \
	../tests/dsuidtests.cpp \
	../tests/event_systemcondition_test.cpp \
	../tests/event_trigger_tests.cpp \
	../tests/eventrequesthandlertest.cpp \
	../tests/eventtests.cpp \
	../tests/iconvtests.cpp \
	../tests/jsontests.cpp \
	../tests/meteringtests.cpp \
	../tests/model-autocluster_tests.cpp \
	../tests/model-cluster_tests.cpp \
	../tests/model-mainloop_tests.cpp \
	../tests/modeltests.cpp \
	../tests/property_xmlparser_tests.cpp \
	../tests/propertysystemtests.cpp \
	../tests/restfulapitests.cpp \
	../tests/securitytests.cpp \
	../tests/sensor_data_uploader.cpp \
	../tests/sensorconversiontest.cpp \
	../tests/sqlite3_wrapper.cpp \
	../tests/statetests.cpp \
	../tests/systeminfo_tests.cpp \
	../tests/testrunner.cpp \
	../tests/util/ds485-bus-mockups.h \
	../tests/util/dss_instance_fixture.cpp \
	../tests/util/dss_instance_fixture.h \
	../tests/util/modelmaintenance-mockup.h \
	../tests/vdc-db.cpp \
	../tests/webfixture.h \
	../tests/webserver.cpp \
	../tests/webservice_api_tests.cpp \
	../tests/zone_tests.cpp


bin_PROGRAMS += dss

EXTRA_DIST +=	../src/messages/messaging.proto \
				../src/messages/device-scene-table-update.proto \
				../src/messages/vdc-messages.proto \
				../src/messages/vdcapi.proto

CLEANFILES += \
			../src/messaging.pb.cc \
			../src/device-scene-table-update.pb.cc \
	        ../src/vdc-messages.pb.cc \
	        ../src/vdcapi.pb.cc


BUILT_SOURCES += \
			../src/messaging.pb.cc \
			../src/device-scene-table-update.pb.cc \
			../src/vdc-messages.pb.cc \
	        ../src/vdcapi.pb.cc

noinst_LIBRARIES += libdsscore.a libcivetweb.a libunix.a libprotomessages.a

nodist_libprotomessages_a_SOURCES = \
			../src/messaging.pb.cc \
			../src/device-scene-table-update.pb.cc \
			../src/vdc-messages.pb.cc \
	        ../src/vdcapi.pb.cc

libprotomessages_a_CXXFLAGS = \
			-I$(top_srcdir) \
			-I$(top_builddir)/src \
			-Wno-misleading-indentation \
			$(LIBPROTOBUF_CFLAGS)

libdsscore_a_CXXFLAGS = \
			-I$(top_srcdir) \
			-I$(top_srcdir)/src \
			-I$(top_builddir)/src \
			$(JSONC_CFLAGS) \
			$(ICAL_CFLAGS) \
			$(DSM_API_CFLAGS) \
			$(OPENSSL_CFLAGS) \
			$(AVAHI_CFLAGS) \
			$(CURL_CFLAGS) \
			$(LIBRRD_CFLAGS) \
			$(EXPAT_CFLAGS) \
			$(GCOV_CFLAGS) \
			$(OSSP_UUID_CFLAGS) \
			$(BOOST_CPPFLAGS) \
			$(LIBPROTOBUF_CFLAGS) \
			$(LIBCOMMCHANNEL_CFLAGS) \
			$(LIBDSUID_CFLAGS) \
			$(libds_a_CPPFLAGS) \
			$(SOLTRACK_CFLAGS) \
			$(PTHREAD_CFLAGS)

libdsscore_a_LIB = \
        $(libds_asio_a_LIB) \
        $(libds_avahi_a_LIB) \
        $(libds_api_a_LIB) \
        $(libds_backend_a_LIB) \
        $(libds_locale_a_LIB) \
        $(libds_model_a_LIB) \
        $(libds_media_library_a_LIB)

dss_SOURCES = ../src/main.cpp

dss_CXXFLAGS = \
			-I$(top_srcdir)/src \
			-I$(top_builddir)/src \
			$(GCOV_CFLAGS) \
			$(ICAL_CFLAGS) \
            $(LIBPROTOBUF_CFLAGS) \
            $(LIBCOMMCHANNEL_CFLAGS) \
			$(LIBDSUID_CFLAGS) \
			$(OSSP_UUID_CFLAGS) \
			$(BOOST_CPPFLAGS) \
			$(SQLITE3_CFLAGS)

COMMON_LDFLAGS = libdsscore.a libunix.a libcivetweb.a libprotomessages.a \
      $(DSM_API_LIBS) \
      $(BOOST_LDFLAGS) \
      $(ICAL_LIBS) \
      $(OPENSSL_LIBS) \
      $(AVAHI_LIBS) \
      $(CURL_LIBS) \
      $(LIBRRD_LIBS) \
      $(EXPAT_LIBS) \
      $(GCOV_LIBS) \
      $(LIBTCMALLOC_LIBS) \
      $(JSONC_LIBS) \
      $(LIBPROTOBUF_LIBS) \
      $(LIBCOMMCHANNEL_LIBS) \
      $(LIBDSUID_LIBS) \
      $(OSSP_UUID_LIBS) \
      $(LTLIBICONV) \
      $(BOOST_FILESYSTEM_LIB) \
      $(BOOST_PROGRAM_OPTIONS_LIB) \
      $(BOOST_SYSTEM_LIB) \
      $(BOOST_THREAD_LIB) \
      $(BOOST_CHRONO_LIB) \
      $(SQLITE3_LIBS) \
      $(libds_connector_a_LIB) \
      $(libdsscore_a_LIB) \
      $(SOLTRACK_LDFLAGS) \
      $(SOLTRACK_LIBS)

dss_LDADD = $(COMMON_LDFLAGS)

if BUILD_SCRIPTING
dss_LDADD += libscripting.a $(JS_LIBS)
endif

../src/dss.cpp: build_info.h


TESTS += dss-test
check_PROGRAMS += dss-test
dss_test_SOURCES = \
	../src/backend-vdcs-test.cpp \
	../src/businterface-test.cpp \
	../src/cache/apartment-proxy-test.cpp \
	../src/cache/apartment-status-test.cpp \
	../src/cache/cache-db-test.cpp \
	../src/cache/cache-updater-test.cpp \
	../src/cache/device-cache-test.cpp \
	../src/datetools-test.cpp \
	../src/device-info-test.cpp \
	../src/ds-apartment/installation-test.cpp \
	../src/ds-apartment/remote-connectivity-test.cpp \
	../src/ds-backend/measurements-source-test.cpp \
	../src/ds-backend/signals-source-test.cpp \
	../src/ds-backend/timed-measurements-source-test.cpp \
	../src/ds-backend/uploader-test.cpp \
	../src/ds-model-test.cpp \
	../src/ds-scenarios-test.cpp \
	../src/ds485-query-test.cpp \
	../src/ds485/dsbusinterface-test.cpp \
	../src/ds485types-test.cpp \
	../src/dsm-api-mock.cpp \
	../src/dss_instance_fixture.cpp \
	../src/event-test.cpp \
	../src/hal/climate-device-state-machine-test.cpp \
	../src/hal/hardware-abstraction-test.cpp \
	../src/hal/joker-device-state-machine-test.cpp \
	../src/hal/light-device-multi-channel-test.cpp \
	../src/hal/light-device-state-machine-test.cpp \
	../src/hal/shade-device-state-machine-test.cpp \
	../src/handler/action-execute-test.cpp \
	../src/handler/event-logger-test.cpp \
	../src/handler/system_triggers-test.cpp \
	../src/metering/archives-test.cpp \
	../src/metering/config-test.cpp \
	../src/metering/metering-test.cpp \
	../src/metering/power-states-test.cpp \
	../src/metering/rrd-interface-test.cpp \
	../src/model-features-test.cpp \
	../src/model/apartment-test.cpp \
	../src/model/cluster-test.cpp \
	../src/model/busscanner-test.cpp \
	../src/model/buttonattributes-test.cpp \
	../src/model/buttonmanipulator-test.cpp \
	../src/model/device-mock-test.cpp \
	../src/model/device-mock.cpp \
	../src/model/device-property-tree-test.cpp \
	../src/model/deviceinterface-test.cpp \
	../src/model/device-test.cpp \
	../src/model/modelevent-test.cpp \
	../src/model/modelconst-test.cpp \
	../src/model/modelmaintenance-test.cpp \
	../src/model/powerline-test.cpp \
	../src/model/shademanipulator-test.cpp \
	../src/propertyquery-test.cpp \
	../src/property-parser-test.cpp \
	../src/sceneaccess-test.cpp \
	../src/sensoraggregator-test.cpp \
	../src/structuremanipulator-test.cpp \
	../src/vdc-element-reader-test.cpp \
	../src/web/handler/apartmentrequesthandler-test.cpp \
	../src/web/handler/circuitrequesthandler-test.cpp \
	../src/web/handler/deviceinterfacerequesthandler-test.cpp \
	../src/web/handler/devicerequesthandler-test.cpp \
	../src/web/handler/meteringrequesthandler-test.cpp \
	../src/web/handler/structurerequesthandler-test.cpp \
	../src/web/webrequests-test.cpp

dss_test_CPPFLAGS = \
        $(libdsscore_a_CXXFLAGS) \
        -DABS_SRCDIR=\"@abs_top_srcdir@\" \
        -DABS_BUILDDIR=\"@abs_top_builddir@\"
dss_test_CXXFLAGS =
dss_test_LDADD = \
        $(libds_catch_main_a_LIB) \
        $(COMMON_LDFLAGS)

if BUILD_SCRIPTING
dss_test_SOURCES += \
	../src/scripting/modeljs-test.cpp
dss_test_CXXFLAGS += \
	$(JS_CFLAGS)
dss_test_LDADD += \
	libscripting.a $(JS_LIBS)
endif

../src/comm-channel.h: ../src/messaging.pb.h
../src/comm-channel.cpp: ../src/device-scene-table-update.pb.h


../src/vdc-connection.h: ../src/vdc-messages.pb.h
%.pb.cc %.pb.h: messages/%.proto
	$(MKDIR_P) ../src
	protoc -I$(top_srcdir)/src/messages --cpp_out=../src $(top_srcdir)/src/messages/$(<F)
