#pragma once

#include <ds-api/service-fwd.h>
#include <ds-model/media-library-fwd.h>
#include <ds/clock.h>
#include <ds/system-fwd.h>

#include <boost/noncopyable.hpp>
#include <memory>

namespace dsMediaLibrary {

class MediaLibraryApi : public boost::noncopyable {
public:
  virtual ~MediaLibraryApi() = default;
  [[nodiscard]] virtual dsModel::Clip clip(const dsModel::ClipId &) const = 0;
  virtual void deleteClip(const dsModel::ClipId &) = 0;
  [[nodiscard]] virtual dsModel::Clips clips() const = 0;
  [[nodiscard]] virtual dsModel::ClipId addClip(dsModel::Clip &&) = 0;
  virtual void setClipName(const dsModel::ClipId &, const std::string &) = 0;
  virtual void setClipUri(const dsModel::ClipId &, const std::string &) = 0;
  virtual void setClipDuration(const dsModel::ClipId &, const ds::Clock::duration &) = 0;
};

std::unique_ptr<MediaLibraryApi> makeMediaLibraryApi(ds::System &);
std::unique_ptr<dsApi::Service> makeMediaLibraryService(MediaLibraryApi &);

} // namespace dsMediaLibrary
