// Generated file.  DO NOT EDIT!
// source: apartment.yaml

// clang-format off

#pragma once


/// Apartment
///
/// Basic apartment information and infrastructure

#include "apartment-fwd.h"
#include <ds/enum.h>
#include <ds/clock.h>

#include "api-revision-fwd.h"
#include "applications-fwd.h"
#include "devices-fwd.h"
#include "groups-fwd.h"
#include "installation-fwd.h"
#include "meterings-fwd.h"
#include "scenarios-fwd.h"
#include "user-defined-states-fwd.h"
#include "api-revision.h"
#include "installation.h"
#include "groups.h"
#include "common.h"

#include <ds/json.h>

DS_REFLECTED_ENUM((dsModel), ApartmentApplicationType,
    (none)
    (ventilationUnit)
);

DS_REFLECTED_ENUM((dsModel), DayNight,
    (none)
    (day)
    (night)
);

namespace dsModel {
struct ApartmentApplications {
  Ventilation ventilationUnit{};

  ~ApartmentApplications();
};

struct ApartmentApplicationsStatus {
  VentilationStatus ventilationUnit{};

  ~ApartmentApplicationsStatus();
};

struct ApartmentAlarm {

  /// User given name
  ///
  /// Example: Kitchen
  std::string name{};

  ~ApartmentAlarm();
};

struct ApartmentSecurity {
  ApartmentAlarm alarm1{};
  ApartmentAlarm alarm2{};
  ApartmentAlarm alarm3{};
  ApartmentAlarm alarm4{};

  ~ApartmentSecurity();
};

struct ApartmentAttributes {

  /// User given apartment name
  ///
  /// Example: My digitalSTROM Home
  std::string name{};
  ApartmentSecurity security{};
  InstallationId installation{};
  std::vector<ZoneId> zones{};
  std::vector<DSDeviceId> dsDevices{};
  std::vector<ClusterId> clusters{};
  ApartmentApplications applications2{};

  ~ApartmentAttributes();
};

struct ApartmentIncluded {
  Installation installation{};
  std::vector<DSDevice> dsDevices{};
  std::vector<Submodule> submodules{};
  std::vector<FunctionBlock> functionBlocks{};
  std::vector<Zone> zones{};
  std::vector<Scenario> scenarios{};
  std::vector<UserDefinedState> userDefinedStates{};
  std::vector<Floor> floors{};
  std::vector<Cluster> clusters{};
  std::vector<Application> applications{};
  DSServer dsServer{};
  std::vector<Controller> controllers{};
  ApiRevision apiRevision{};
  std::vector<Metering> meterings{};

  ~ApartmentIncluded();
};

struct Apartment {
  ApartmentId id{};
  std::string type = "apartment";
  ds::DateTime lastChanged{};
  ApartmentAttributes attributes{};
  ApartmentIncluded included{};

  ~Apartment();
};

struct ApartmentAccessStatus {
  std::optional<bool> absent{};

  ~ApartmentAccessStatus();
};

struct ApartmentUserStatus {
  std::optional<bool> sleeping{};
  std::optional<bool> holiday{};

  ~ApartmentUserStatus();
};

struct ApartmentSecurityStatus {
  std::optional<bool> panic{};
  std::optional<bool> fire{};
  std::optional<bool> smoke{};
  std::optional<bool> gas{};
  std::optional<bool> pollution{};
  std::optional<bool> alarm1{};
  std::optional<bool> alarm2{};
  std::optional<bool> alarm3{};
  std::optional<bool> alarm4{};
  std::optional<bool> burglaryAlarm{};
  std::optional<bool> burglaryAttempt{};

  ~ApartmentSecurityStatus();
};

struct ApartmentTemperatureStatus {
  TemperatureMode mode{};
  std::optional<bool> ecoPreferred{};

  ~ApartmentTemperatureStatus();
};

struct ApartmentWeatherStatus {
  std::optional<bool> wind{};
  std::optional<bool> rain{};
  std::optional<bool> hail{};
  std::optional<bool> frost{};
  DayNight dayNight{};
  WeatherConditionId condition{};

  /// OpenWeatherMap weather icon. See https://openweathermap.org/weather-conditions
  ///
  /// Example: 10d
  std::string icon{};

  ~ApartmentWeatherStatus();
};

struct ApartmentEnvironmentStatus {

  /// Today's sunrise
  ds::DateTime sunrise{};

  /// Today's sunset
  ds::DateTime sunset{};

  /// Today's civil dawn
  ds::DateTime dawn{};

  /// Today's civil dask
  ds::DateTime dusk{};

  ~ApartmentEnvironmentStatus();
};

struct ApartmentMeasurementStatus {

  /// in degree Celsius
  std::optional<double> temperature{};

  /// in %rH
  std::optional<double> humidity{};

  /// in lux
  std::optional<double> brightness{};

  /// in hPa
  std::optional<double> airPressure{};

  /// in mm in last hour
  std::optional<double> precipitation{};

  /// in m/s
  std::optional<double> windSpeed{};

  /// in m/s
  std::optional<double> windGust{};

  ~ApartmentMeasurementStatus();
};

struct ApartmentStatusAttributes {
  ApartmentAccessStatus access{};
  ApartmentUserStatus user{};
  ApartmentSecurityStatus security{};
  ApartmentTemperatureStatus temperature{};
  ApartmentWeatherStatus weather{};
  ApartmentEnvironmentStatus environment{};
  ApartmentMeasurementStatus measurements{};
  ApartmentApplicationsStatus applications2{};

  ~ApartmentStatusAttributes();
};

struct ApartmentStatusIncluded {
  std::vector<DSDeviceStatus> dsDevices{};
  std::vector<ZoneStatus> zones{};
  std::vector<ClusterStatus> clusters{};
  std::vector<UserDefinedStateStatus> userDefinedStates{};

  ~ApartmentStatusIncluded();
};

struct ApartmentStatus {
  ApartmentId id{};
  std::string type = "apartmentStatus";
  ds::DateTime lastChanged{};
  ApartmentStatusAttributes attributes{};
  ApartmentStatusIncluded included{};

  ~ApartmentStatus();
};

} // namespace dsModel

DS_JSON_DECLARE_STRUCT((dsModel), ApartmentApplications,
    (ventilationUnit)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentApplicationsStatus,
    (ventilationUnit)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentAlarm,
    (name)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentSecurity,
    (alarm1)
    (alarm2)
    (alarm3)
    (alarm4)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentAttributes,
    (name)
    (security)
    (installation)
    (zones)
    (dsDevices)
    (clusters)
    (applications2)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentIncluded,
    (installation)
    (dsDevices)
    (submodules)
    (functionBlocks)
    (zones)
    (scenarios)
    (userDefinedStates)
    (floors)
    (clusters)
    (applications)
    (dsServer)
    (controllers)
    (apiRevision)
    (meterings)
);
DS_JSON_DECLARE_STRUCT((dsModel), Apartment,
    (id)
    (type)
    (lastChanged)
    (attributes)
    (included)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentAccessStatus,
    (absent)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentUserStatus,
    (sleeping)
    (holiday)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentSecurityStatus,
    (panic)
    (fire)
    (smoke)
    (gas)
    (pollution)
    (alarm1)
    (alarm2)
    (alarm3)
    (alarm4)
    (burglaryAlarm)
    (burglaryAttempt)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentTemperatureStatus,
    (mode)
    (ecoPreferred)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentWeatherStatus,
    (wind)
    (rain)
    (hail)
    (frost)
    (dayNight)
    (condition)
    (icon)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentEnvironmentStatus,
    (sunrise)
    (sunset)
    (dawn)
    (dusk)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentMeasurementStatus,
    (temperature)
    (humidity)
    (brightness)
    (airPressure)
    (precipitation)
    (windSpeed)
    (windGust)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentStatusAttributes,
    (access)
    (user)
    (security)
    (temperature)
    (weather)
    (environment)
    (measurements)
    (applications2)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentStatusIncluded,
    (dsDevices)
    (zones)
    (clusters)
    (userDefinedStates)
);
DS_JSON_DECLARE_STRUCT((dsModel), ApartmentStatus,
    (id)
    (type)
    (lastChanged)
    (attributes)
    (included)
);

