#pragma once

#include <ds-api/rest.h>
#include <ds/clock.h>
#include <ds/enum.h>
#include <ds/json.h>

#include "common.h"
#include "meterings-fwd.h"
#include "model-fwd.h"

///
/// Api definitions for deprecated /applications endpoint
///
namespace dsModel {

// deprecated in favour of Temperature in Zone
struct TemperatureApplicationAttributes {
  ZoneApplicationType applicationType{};
  ZoneId zone{};
  std::vector<TemperatureLevel> availableLevels{};
  std::vector<TemperatureSetpoint> setpoints{};
};
using Application = dsApi::VariantResourceData<dsModel::ApplicationId, dsModel::TemperatureApplicationAttributes>;

} // namespace dsModel

DS_JSON_DECLARE_STRUCT((dsModel), TemperatureApplicationAttributes,
                       (applicationType)(zone)(availableLevels)(setpoints));
static constexpr auto dsModelApplicationNameVisitor = ::ds::Visitor{
    [](const std::monostate&) { return ""; },
    [](const dsModel::TemperatureApplicationAttributes&) { return "temperatureApplication"; },
};
DS_JSON_DECLARE_API_VARIANT_RESOURCE_DATA((dsModel), Application, dsModelApplicationNameVisitor);
