// Generated file.  DO NOT EDIT!
// source: media-library.yaml

// clang-format off

#pragma once


/// Media-library
///
/// Media Library clips

#include "media-library-fwd.h"
#include <ds/enum.h>
#include <ds/clock.h>

#include "common-fwd.h"
#include "common.h"

#include <ds/json.h>


/// Defines the type of audio file and its purpose:
///   - `{alarm}` - safety notifications (e.g. fire alarm, smoke detection)
///   - `{doorbell}` - doorbell rings notifications
///   - `{signal}` - miscellaneous notifications without a specific puropse (e.g. telephone ring)
///   - `{text2speech}` - user defined voice notifications
///   - `{user}` - user uploaded files
///
/// Example: alarm
DS_REFLECTED_ENUM((dsModel), ClipCategoryId,
    (none)
    (alarm)
    (doorbell)
    (signal)
    (text2speech)
    (user)
);

namespace dsModel {

/// Audio clip metadata
/// Properties `{language}`, `{text}` and `{voice}` are present in the object only for voice notifications
struct ClipResource {

  /// Relative path to audio file
  ///
  /// Example: /predefined/alarm.mp3
  std::string uri{};

  /// Example: 10
  ds::Clock::duration duration{};
  Language language{};

  /// Voice notification text
  ///
  /// Example: Boiling finished
  std::string text{};

  /// Notification voice
  ///
  /// Example: John
  std::string voice{};

  ~ClipResource();
};

struct ClipAttributes {
  Translatable name{};
  ClipCategoryId category{};
  std::vector<ClipResource> resources{};

  ~ClipAttributes();
};

struct Clip {
  ClipId id{};
  std::string type = "clip";
  ds::DateTime lastChanged{};
  ClipAttributes attributes{};

  ~Clip();
};

struct Clips {
  std::vector<Clip> clips{};

  ~Clips();
};

} // namespace dsModel

DS_JSON_DECLARE_STRUCT((dsModel), ClipResource,
    (uri)
    (duration)
    (language)
    (text)
    (voice)
);
DS_JSON_DECLARE_STRUCT((dsModel), ClipAttributes,
    (name)
    (category)
    (resources)
);
DS_JSON_DECLARE_STRUCT((dsModel), Clip,
    (id)
    (type)
    (lastChanged)
    (attributes)
);
DS_JSON_DECLARE_STRUCT((dsModel), Clips,
    (clips)
);

