/*
 *  Copyright (c) 2012 digitalSTROM.org, Zurich, Switzerland
 *
 *  This file is part of digitalSTROM Server.
 *
 *  digitalSTROM Server is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  digitalSTROM Server is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __SYSTEM_HANDLERS__
#define __SYSTEM_HANDLERS__

#include "ds/common.h"
#include "event.h"
#include "taskprocessor.h"

namespace dss {
class SystemEvent : public Task {
public:
  SystemEvent(const Event &event);
  virtual ~SystemEvent();
  virtual void run() = 0;

protected:
  Properties m_properties;
  std::string m_evtName;
  EventRaiseLocation m_evtRaiseLocation;
  std::shared_ptr<const Group> m_raisedAtGroup;
  std::shared_ptr<const DeviceReference> m_raisedAtDevice;
  std::shared_ptr<const State> m_raisedAtState;
};
} // namespace dss
#endif
