/*
    Copyright (c) 2021 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not, see <http://www.gnu.org/licenses/>.

*/

#pragma once

#include <ds/enum.h>

#include "model/modelconst.h"

namespace dss::model {} // namespace dss::model

// no ds-model equivalent yet
DS_REFLECTED_ENUM((dss::model), AutomationInputMode,
                  (none)(standard)(inverted)(on_rising_edge)(on_falling_edge)(off_rising_edge)(off_falling_edge)(
                      rising_edge)(falling_edge))

template <>
struct DSToEnum<dss::model::AutomationInputMode, dss::ButtonInputMode, void> {
  static std::optional<dss::model::AutomationInputMode> tryTo(dss::ButtonInputMode x);
};

template <>
struct DSToEnum<dss::ButtonInputMode, dss::model::AutomationInputMode, void> {
  static std::optional<dss::ButtonInputMode> tryTo(dss::model::AutomationInputMode x);
};
