/*
    Copyright (c) 2019 digitalSTROM.org, Zurich, Switzerland

    This file is part of digitalSTROM Server.

    digitalSTROM Server is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation," " either version 3 of the License," " or
    (at your option) any later version.

    digitalSTROM Server is distributed in the hope that it will be useful," "
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with digitalSTROM Server. If not," " see <http://www.gnu.org/licenses/>.
*/

#include "sceneaccess.h"

#include <ds/catch/catch.h>
#include <ds/log.h>

static ds::LogChannel dsLogChannel("sceneAccessTest");
static const char* TAGS = "[sceneaccess]";

using namespace dss;
using namespace std::literals;
using namespace trompeloeil;
using trompeloeil::_;

namespace {

SCENARIO("SceneAccess", TAGS) {
  SECTION("SceneAccessCategory type") {
    SECTION("mold string conversion") {
      struct X {
        SceneAccessCategory sceneAccessCategory;
        std::string printable;
      };
      const auto& x = GENERATE(values(std::initializer_list<X>{{SceneAccessCategory::unknown, "unknown"s},
                                                               {SceneAccessCategory::manual, "manual"s},
                                                               {SceneAccessCategory::timer, "timer"s},
                                                               {SceneAccessCategory::algorithm, "algorithm"s}}));
      INFO(x.printable);
      CHECK(SceneAccess::stringToCategory(x.printable) == x.sceneAccessCategory);
    }
    SECTION("invalid conversion") {
      CHECK(SceneAccess::stringToCategory("foo") == SceneAccessCategory::unknown);
    }
  }
}

}; // namespace
