#/bin/bash

# Extracts translated strings from sources and push them to transifex

set -e

POT_FILE="po/dss-mainline.pot"

FILES=`git ls-files 'src/*.cpp' 'src/*.h' -x 'src/*test.cpp' | grep -v test.cpp | tr '\n' ' '`

xgettext --c++ --force-po --from-code=UTF-8 \
  --package-name=dss-mainline \
  --keyword=dsMessage:1,1t --keyword=dsMessage:1c,2,2t --keyword=dsMessage:1,2,3t --keyword=dsMessage:1c,2,3,4t \
  --keyword=dsTr:2,2t --keyword=dsTr:2c,3,3t \
  --keyword=dsApiTranslation:2c,3,3t \
  --keyword=dsTr:2,3,4t --keyword=dsTr:2c,3,4,5t \
  -o ${POT_FILE} ${FILES}

# Fix content type after xgettext.
# Is there a way to persuade xgettext to set UTF-8 content type?
sed -i 's%^"Content-Type: text/plain; charset=CHARSET\\n"%"Content-Type: text/plain; charset=UTF-8\\n"%' ${POT_FILE}

# Remove POT-Creation-Date line to empty modifications
sed -i '/^"POT-Creation-Date:/d' ${POT_FILE}

git add --all ${POT_FILE}

tx push --source
